#!/usr/bin/perl
#==========================================================================#
#  B.Forum Ver.1.01                                                      #
#  󥹥ȡ                                                          #
#  Encode = EUC                                                          #
#  Hiroaki,Sakuma( sakuma@beetas.org )                                   #
#  BEETAS.org( info@beetas.org )                                         #
#                                                                          #
# Υץꥱϥץ󥽡Ǥ.                          #
# ̵ǻѤ뤳ȤǤޤ.                                            #
# ʤ, ܺ٤ʻѾ/ǿˤĤƤϲȤ.           #
# http://www.beetas.org/                                                   #
#                                                                          #
# ------------------------------------------------------------------------ #
# Copyright 2001-2002 BEETAS.org All Rights Reserved.                      #
#                                                                          #
#==========================================================================#
package Bforum::Installer;
$version = '1.01-3';
$revision = '1.00.0001';
$rcfile = '.bforumrc';
#$rcfile = 'bforum.conf';

require 5.005;

# ̩ʸˡå
use strict;

# Ѥѿ
use vars qw($version $revision $rcfile);
use vars qw($pwd $code $jcode $convert $verpose $email);
use vars qw(@BackupFile @CopyDir @CopyFile);
use vars qw(%init %dir %ftp);

# Хåեեå
$| = 1;

# ɸ⥸塼
use File::Copy;
use File::Path;

# Хååפե
@BackupFile = (".bforumrc","B.Forum/.default","B.Forum/.htaccess","B.Forum/BF.bfa","B.Forum/BF.bfa.fileupload","B.Forum/BF.bfa.namazu");

# ԡǥ쥯ȥ
@CopyDir = ("B.Forum","B.Forum/.cache","B.Forum/.PLUGIN");
# ԡե
@CopyFile = (".bforumrc","bforum.cgi","Bforum.pm","B.Forum/.default","B.Forum/.htaccess","B.Forum/BF.bfa","B.Forum/BF.bfa.fileupload","B.Forum/BF.bfa.namazu");

&main;

sub main {

	&init;

	if ($ARGV[0] eq '-h' || $ARGV[0] eq '--help') { &help; }
	&check_japanese;
	&check_install;
	&install_dir;
	&install_modules;
	&backup;
	&copy_dir;
	&copy_file;
	&permission;
	&finish;

	exit(0);

}

sub init {

	## PWD
	use Cwd;
	$pwd = Cwd::cwd();

	printf ("pwd" . ('.' x (75 - 3 - length($pwd))) . " %s\n",$pwd);

	## codeǧ
	$code = $ENV{'LANGUAGE'} || $ENV{'LC_ALL'} || $ENV{'LC_MESSAGES'} || $ENV{'LANG'};
	$code =~ s/^.._..\.([a-z]*).*$/$1/;

	printf ("code" . ('.' x (75 - 4 - length($code || "NG"))) . " %s\n",($code || "NG"));

	## jcode.plǧ
	$jcode = $ENV{'JCODE'};

	printf ("jcode" . ('.' x (75 - 5 - length($jcode || "NG"))) . " %s\n",($jcode || "NG"));

	if ($ARGV[0] eq '-v' || $ARGV[0] eq '--verpose') { $verpose = 1; }

}

sub check_japanese {

	my ($tmp1);

	while (1) {
		$tmp1 = &print("ιԤɽƤޤ\nIf you can't read upper line, type to 'exit' please.","Y/(N)","N");
		if ($tmp1 =~ /[yY]/) {
			return;
		} elsif ($tmp1 =~ /[nN]/) {
			print "Bye\n";
			exit(0);
		}
	}

}

sub check_install {

	my ($tmp1);

	while (1) {
		print &convert("Υץꥱϥץ󥽡Ǥ\n");
		print &convert("̵ǻѤ뤳ȤǤޤ\n");
		print &convert("ܺ٤ʻѾ/ǿˤĤƤϲȤ\n");
		print "http://www.beetas.org/\n";
		$tmp1 = &print("󥹥ȡ³Ԥޤ","Y/(N)","N");
		if ($tmp1 =~ /[yY]/) {
			return;
		} elsif ($tmp1 =~ /[nN]/) {
			print "Bye\n";
			exit(0);
		}
	}

}

sub install_dir {

	my ($tmp1);

	while (1) {
		$tmp1 = &print("󥹥ȡΥǥ쥯ȥꤷƤ.","$pwd","$pwd");
		if ($tmp1) {
			&_path($tmp1);
			$dir{'install'} = $tmp1;
			if (!-d $tmp1) {
				if (&create_dir($tmp1)) { return; }
			} elsif (! -r $tmp1 ||! -w $tmp1 ||! -x $tmp1) {
				print &convert("ѡߥåޤ.\n");
			} else {
				return;
			}
		}
	}

}

sub create_dir {

	my ($tmp1);

	while (1) {
		$tmp1 = &print("ꤵ줿ǥ쥯ȥ꤬Ĥޤ. ޤ","(Y)/N","Y");
		if ($tmp1 =~ /[yY]/) {
			print &convert("ǥ쥯ȥƤޤ... $_[0]\n");
			mkpath ($_[0],undef,0777);
			return 1;
		} elsif ($tmp1 =~ /[nN]/) {
			return;
		}
	}

}

sub install_modules {

	my ($tmp1,$tmp2,$tmp3);

	while(1) {
		$tmp1 = &print("Perl⥸塼Archive::TarCompress::Zlibͥåȥ饤󥹥ȡ뤷ޤ","(Y)/N","Y");
		if ($tmp1 =~ /[yY]/) {

			while (1) {

				$tmp2 = &print("᡼륢ɥ쥹ϤƤ.","YourMailAddress","");
				if ($tmp2 =~ /.+\@.+\..+/) {

					$email = $tmp2;

					&ftp;
					foreach ("Archive::Tar","Compress::Zlib") {
						mkpath("tmp",undef,0777);
						if ($tmp3 = &download($_)) {
							&install_perl_modules($tmp3);
						}
						rmtree("tmp",undef,undef);
					}

					return;

				} else {
					print &convert("ɥ쥹Ǥ.\n");
				}

			}

		} elsif ($tmp1 =~ /[nN]/) {
			return;
		}
	}

}

sub ftp {

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	use Socket;

	print &convert("www.beetas.orgHTTP³Ƥޤ.\n");

	socket(HTTP,PF_INET,SOCK_STREAM,getprotobyname('tcp')) || print &convert("åȤǤޤ.$!\n");

	connect(HTTP,sockaddr_in(80,inet_aton("www.beetas.org"))) || print &convert("Ȥ³Ǥޤ.$!\n");

	send(HTTP,"GET /Installer/bforum-$revision HTTP/1.1\r\n",0);
	send(HTTP,"Host: www.beetas.org\r\n",0);
	send(HTTP,"UserAgent: B.ForumInstaller/$version($revision)\r\n",0);
	send(HTTP,"\r\n",0);

	print &convert("www.beetas.orgǡƤޤ.\n");

	## إå(ΤƤ)
	# UNIX: 
	# NT: ɬ(?)
	#recv(HTTP,$tmp2,1000000,0);
	## ǡ
	recv(HTTP,$tmp2,1000000,0);
	close(HTTP);

#	use IO::Socket;
#
#	print &convert("www.beetas.orgHTTP³Ƥޤ.\n");
#
#	$tmp1 = new IO::Socket::INET(PeerAddr => "www.beetas.org", PeerPort => "80", Proto => 'tcp') || print &convert("Ȥ³Ǥޤ.$!\n");
#
#	$tmp1->send("GET /Installer/bforum-$revision HTTP/1.1\r\n");
#	$tmp1->send("Host: www.beetas.org\r\n");
#	$tmp1->send("UserAgent: B.ForumInstaller/$version($revision)\r\n");
#	$tmp1->send("\r\n");
#
#	print &convert("www.beetas.orgǡƤޤ.\n");
#
#	## إå(ΤƤ)
##	$tmp1->recv($tmp2,1000000,0);
#	## ǡ
#	$tmp1->recv($tmp2,1000000,0);
#	$tmp1->close();

	foreach $tmp3 (split("\n",$tmp2)) {
	print;
		chomp ($tmp3);
		if ($tmp3 =~ /^\s*#/o) { next; }
		($tmp3) = split (/#\s+/,$tmp3);
		($tmp3) = split (/\s+#/,$tmp3);
		if (!$tmp3) { next; }
		if ($tmp3 =~ /\s*([^\s]+?)\s+(.*?)\s*$/gio) { $ftp{$1} = $2; }

	}

}

sub download {

	my ($tmp1);

	eval("use Net::FTP");

	if ($@) {
		print &convert("Net::FTP󥹥ȡ뤵Ƥޤ.\n");
		return;
	}

	if ($verpose) { print &convert("$ftp{$_[0]}ɤޤ...\n"); }

	if ($ftp{$_[0]} =~ /ftp:\/\/([^\/]*)(.*)\/(.*)$/) {

		print &convert("FTP($1)³Ƥޤ.\n");

		if (!($tmp1 = Net::FTP->new($1))) {
			print &convert("FTP($1)³Ǥޤ.\n");
			return;
		}

		$tmp1->login("anonymous",$email);
		$tmp1->binary;
		$tmp1->get("$2/$3","tmp/$3") || print &convert("ե($3)Ǥޤ.\n");
		$tmp1->quit;

		if (-f "tmp/$3") {
			return $3;
		} else {
			print &convert("ե($3)Ǥޤ.\n");
			return;
		}

	} else {

		print &convert("FTP($1)³Ǥޤ.\n");
		return;

	}


}

sub install_perl_modules {

	my ($tmp1);

	chdir("$pwd/tmp/");

	if ($verpose) { print &convert("Ÿޤ...\n"); }
	&command("gunzip -c $_[0] | tar -xvf -");

	if ($tmp1 = &search_makefile("./")) {

		if ($tmp1 =~ /^(.*)\/(.*)$/) {

			chdir ("$pwd/tmp/$1/");

			if ($verpose) { print &convert("Makefileޤ...\n"); }
			&command("perl Makefile.PL PREFIX=\"$dir{'install'}\"");

			if ($verpose) { print &convert("ѥ뤷ޤ...\n"); }
			&command("make");

			if ($verpose) { print &convert("ƥȤޤ...\n"); }
			&command("make test");

			if ($verpose) { print &convert("󥹥ȡ뤷ޤ...\n"); }
#			&command("make install");
			&command("cp -R ./blib/lib/* $dir{'install'}");
			&command("cp -fR ./blib/arch/* $dir{'install'}");

			chdir ("$pwd/tmp/");

		}

	} else {

		print &convert("Makefile.PLĤޤ. ʥ⥸塼Ǥ.\n");
		print &convert("󥹥ȡ򥹥åפޤ.\n");

	}

	chdir("$pwd/");

	return;

}

sub command {

	my (@tmp1);

	if ($verpose) { print &convert("$_[0]\n"); }
	open (CMD,"$_[0] |");
	@tmp1 = (<CMD>);
	foreach (@tmp1) {
		if ($verpose) { print &convert("> $_"); }
	}
	close (CMD);

	return;

}

sub search_makefile {

	my ($tmp1);
	my (@tmp2);

	foreach (<$_[0]/*>) {
		if (-d $_) { push (@tmp2,$_); }
		if (-f $_ && $_ =~ /\/Makefile.PL$/) { return($_); }
	}

	foreach (@tmp2) {
		$tmp1 = &search_makefile ($_);
		if ($tmp1) { return($tmp1) };
	}

	return;

}

sub backup {

	if (!$verpose) { print &convert("ŤեХååפƤޤ...\n"); }
	foreach (@BackupFile) {
		if (-f "$dir{'install'}/$_") {
			if ($verpose) { print &convert("ŤեХååפƤޤ... $_ => $_.old\n"); }
			rename ("$dir{'install'}/$_","$dir{'install'}/$_.old");
		}
	}

}

sub copy_dir {

	if (!$verpose) { print &convert("ǥ쥯ȥ򥳥ԡƤޤ...\n"); }
	foreach (@CopyDir) {
		if ($verpose) { print &convert("ǥ쥯ȥ򥳥ԡƤޤ... $_\n"); }
		mkpath ("$dir{'install'}/$_");
	}

}

sub copy_file {

	my ($tmp1);

	if (!$verpose) { print &convert("ե򥳥ԡƤޤ...\n"); }
	foreach (@CopyFile) {
		if ($verpose) { print &convert("ե򥳥ԡƤޤ... $_\n"); }
		$tmp1 = $_;
		$tmp1 =~ s/^(.*)\/.+$/$1/;
		$tmp1 ||= $_;
		copy ($_,"$dir{'install'}/$tmp1");
	}

}

sub permission {

	my ($tmp1);

	while(1) {
		$tmp1 = &print("֥Ф'root', '" . getlogin . "'¤ưޤ","Y/(N)","N");
		if ($tmp1 =~ /[yY]/) {
			if (!$verpose) { print &convert("ѡߥåѹƤޤ...\n"); }
			foreach (["0600",".bforumrc"],["0700","bforum.cgi"],["0700","auto/"],["0700","auto/Bforum/"],["0600",<auto/Bforum/*>],["0700","B.Forum/"],["0600","B.Forum/BF.bfa"],["0600","B.Forum/.default"],["0700","B.Forum/.cache"],["0700","B.Forum/.language/"],["0600",<B.Forum/.language/*>],["0600","B.Forum/.PLUGIN"]) {
				if (chmod ($_->[0],$_->[1])) {
					if ($verpose) { print &convert("ѡߥåѹƤޤ... $_->[1]($_->[0])\n"); }
				} else {
					print &convert("ѡߥåѹޤ... $_->[1]($_->[0])\n");
				}
			}
			return;
		} elsif ($tmp1 =~ /[nN]/) {
			if (!$verpose) { print &convert("ѡߥåѹƤޤ...\n"); }
			foreach (["0644",".bforumrc"],["0755","bforum.cgi"],["0755","auto/"],["0755","auto/Bforum/"],["0644",<auto/Bforum/*>],["0777","B.Forum/"],["0666","B.Forum/BF.bfa"],["0644","B.Forum/.default"],["0777","B.Forum/.cache"],["0755","B.Forum/.language/"],["0644",<B.Forum/.language/*>],["0644","B.Forum/.PLUGIN"]) {
				if (chmod ($_->[0],$_->[1])) {
					if ($verpose) { print &convert("ѡߥåѹƤޤ... $_->[1]($_->[0])\n"); }
				} else {
					print &convert("ѡߥåѹޤ... $_->[1]($_->[0])\n");
				}
			}
			return;
		}
	}

}

sub finish {

	my ($tmp1);

	if (&print("󥹥ȡ뤬λޤɬREADME.EUCɤǲɤߤޤ","(Y)/N","Y") =~ /[yY]/) {
		foreach ("less","more") {
			if (system($_,"README.EUC") == 0) {
				$tmp1 = 1;
				last;
			}
		}
		if (!$tmp1) { print &convert("README.EUC򳫤ޤǤ\n"); }
	}
	print &convert("B.Forum򥤥󥹥ȡĺ꤬Ȥޤ\n");
	print &convert("ǿ䥵ݡȤϥ֥Ȥ\n");
	print "\n";
	print "http://www.beetas.org/\n";

}

sub help {

	print "\n";
	print &convert("Ȥ\n");
	print "\n";
	print "\$ ./install.pl [-v][-h] [--verpose] [--help]\n";
	print "\n";
	print &convert("[ץ]\n");
	print &convert("   -v --verpose   ܺɽǼ¹\n");
	print &convert("   -h --help      Υåɽ\n");
	exit(0);

}


sub print {

	my ($tmp1,$tmp2);

	print &convert("$_[0] \[$_[1]\] ");
	$tmp1 = <STDIN>;
	chomp ($tmp1);
	if ($tmp1 =~ /(exit|quit)/) {
		print "Bye\n";
		exit(1);
	}
	if (!$tmp1) {
		return $_[2];
	} else {
		return $tmp1;
	}

}

sub convert {

	if ($code ne 'euc' && $jcode) {

		if (!$init{'jcode'}) {
			$init{'jcode'} = 1;
			eval ("require \"$jcode\"");
			if ($@) { return $_[0]; }
		}

		$convert = $_[0];
		&jcode::convert(\$convert,$code,'euc','z');
		return $convert;

	} else {

		return $_[0];

	}

}


sub _path {
	$_[0] =~ tr/\\:/\//s;
	if ($_[0] !~ /^(\/|~|\w:|:)/) {
		$_[0] = $pwd . "/" . $_[0];
		$_[0] =~ s/\/\.\//\//go;
		while ($_[0] =~ /[^\/]+\/\.\.\//o) {
			$_[0] =~ s/[^\/]+\/\.\.\///go;
		}
	}
	return $_[0];
}

